-- name: [CS] Legacy Models Pack
-- description: A Pack that adds DJ Toad and Keeb Waluigi back ingame!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

if not _G.charSelectExists then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gGlobalSoundSource)
            djui_chat_message_create("\\#ffffa0\\[CS] Legacy Models requires Character Select to be enabled.\nPlease rehost with it enabled.")
        end
    end)
    return
end

local MARIO_SOUNDS = {
    [0] = SOUND_MARIO_YAH_WAH_HOO,
    SOUND_MARIO_HOOHOO,
    SOUND_MARIO_YAHOO,
    SOUND_MARIO_UH,
    SOUND_MARIO_HRMM,
    SOUND_MARIO_WAH2,
    SOUND_MARIO_WHOA,
    SOUND_MARIO_EEUH,
    SOUND_MARIO_ATTACKED,
    SOUND_MARIO_OOOF,
    SOUND_MARIO_OOOF2,
    SOUND_MARIO_HERE_WE_GO,
    SOUND_MARIO_YAWNING,
    SOUND_MARIO_SNORING1,
    SOUND_MARIO_SNORING2,
    SOUND_MARIO_WAAAOOOW,
    SOUND_MARIO_HAHA,
    SOUND_MARIO_HAHA_2,
    SOUND_MARIO_UH2,
    SOUND_MARIO_UH2_2,
    SOUND_MARIO_ON_FIRE,
    SOUND_MARIO_DYING,
    SOUND_MARIO_PANTING_COLD,
    SOUND_MARIO_PANTING,
    SOUND_MARIO_COUGHING1,
    SOUND_MARIO_COUGHING2,
    SOUND_MARIO_COUGHING3,
    SOUND_MARIO_PUNCH_YAH,
    SOUND_MARIO_PUNCH_HOO,
    SOUND_MARIO_MAMA_MIA,
    SOUND_MARIO_GROUND_POUND_WAH,
    SOUND_MARIO_DROWNING,
    SOUND_MARIO_PUNCH_WAH,
    SOUND_MARIO_YAHOO_WAHA_YIPPEE,
    SOUND_MARIO_DOH,
    SOUND_MARIO_GAME_OVER,
    SOUND_MARIO_HELLO,
    SOUND_MARIO_PRESS_START_TO_PLAY,
    SOUND_MARIO_TWIRL_BOUNCE,
    SOUND_MARIO_SNORING3,
    SOUND_MARIO_SO_LONGA_BOWSER,
    SOUND_MARIO_IMA_TIRED,
    SOUND_MARIO_LETS_A_GO,
    SOUND_MARIO_OKEY_DOKEY
}

local E_MODEL_KEEBWAH = smlua_model_util_get_id("keeb_wah_geo")
local E_MODEL_DJBUP = smlua_model_util_get_id("dj_bup_geo")

local TEX_DJBUP = get_texture_info("djtoad-icon")
local TEX_KEEBWAH = get_texture_info("keebwaluigi-icon")

local PALETTE_DJBUP = {
    [PANTS]  = {r = 0x4c, g = 0x2c, b = 0xd3},
    [SHIRT]  = {r = 0xff, g = 0xff, b = 0xff},
    [GLOVES] = {r = 0xff, g = 0xff, b = 0xff},
    [SHOES]  = {r = 0x68, g = 0x40, b = 0x1b},
    [HAIR]   = {r = 0x73, g = 0x06, b = 0x00},
    [SKIN]   = {r = 0xfe, g = 0xd5, b = 0xa1},
    [CAP]    = {r = 0xff, g = 0x00, b = 0x00},
    [EMBLEM] = {r = 0xff, g = 0x00, b = 0x00},
}

local PALETTE_KEEBWAH = {
    [PANTS]  = {r = 0x16, g = 0x16, b = 0x27},
    [SHIRT]  = {r = 0x61, g = 0x26, b = 0xb0},
    [GLOVES] = {r = 0xff, g = 0xff, b = 0xff},
    [SHOES]  = {r = 0xfe, g = 0x76, b = 0x00},
    [HAIR]   = {r = 0x73, g = 0x53, b = 0x00},
    [SKIN]   = {r = 0xfe, g = 0xc1, b = 0x79},
    [CAP]    = {r = 0x61, g = 0x26, b = 0xb0},
    [EMBLEM]  = {r = 0x4c, g = 0x2c, b = 0xd3},
}

CT_DJBUP = _G.charSelect.character_add("DJ Toad", {"The early Toad model!", "Used in SM64Ex-Coop!"}, "Djoslin0", { r = 50,  g = 50,  b = 255 }, E_MODEL_DJBUP, CT_MARIO, TEX_DJBUP, 0.8)
_G.charSelect.character_add_palette_preset(E_MODEL_DJBUP, PALETTE_DJBUP)
CT_KEEBWAH = _G.charSelect.character_add("Keeb Waluigi", {"The early Waluigi model!", "Used in SM64Ex-Coop and Early versions of CoopDx"}, "Keeberghrh", { r = 130, g = 25,  b = 130 }, E_MODEL_KEEBWAH, CT_WALUIGI, TEX_KEEBWAH, 1.1)
_G.charSelect.character_add_palette_preset(E_MODEL_KEEBWAH, PALETTE_KEEBWAH)

--- @param cond boolean
--- Human readable ternary operator
function if_then_else(cond, ifTrue, ifFalse)
    if cond then return ifTrue end
    return ifFalse
end

--- @param m MarioState
--- @param sound CharacterSound
local function character_sound(m, sound)
    if obj_has_model_extended(m.marioObj, E_MODEL_DJBUP) ~= 0 then
        play_sound_with_freq_scale(MARIO_SOUNDS[sound], m.marioObj.header.gfx.cameraToObject, 1.25)
        return NO_SOUND
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sound)